## mingw-w64-abinit-10.4.7-1.src.tar.zst

=== src/52_fft_mpi_noabirule/CMakeLists.txt ===
#
# 52_fft_mpi_noabirule
#
add_library(52_fft_mpi_noabirule STATIC
  defs_fftdata.F90
  m_fftw3.F90
  m_dfti.F90
  m_fftcore.F90
  m_fft_mesh.F90
  m_sgfft.F90
  m_sg2002.F90
)

set_target_properties(52_fft_mpi_noabirule
  PROPERTIES
  Fortran_MODULE_DIRECTORY ${CMAKE_BINARY_DIR}/modules)

target_include_directories(52_fft_mpi_noabirule
  PRIVATE
  ${CMAKE_BINARY_DIR}
  ${CMAKE_SOURCE_DIR}/shared/common/src/incs
  PUBLIC
  ${CMAKE_BINARY_DIR}/modules
)

target_compile_definitions(52_fft_mpi_noabirule
  PRIVATE
  HAVE_CONFIG_H
)

target_link_libraries(52_fft_mpi_noabirule
  PUBLIC
  abinit::44_abitools
  abinit::51_manage_mpi
)

if(OpenMP_FOUND)
  target_link_libraries(52_fft_mpi_noabirule
    PUBLIC
    OpenMP::OpenMP_Fortran)
endif()

if (ABINIT_FFT_FLAVOR MATCHES "GOEDECKER")
  # no linking required
else()
  target_link_libraries(52_fft_mpi_noabirule
    PUBLIC
    abinit::fft)
endif()

add_library(abinit::52_fft_mpi_noabirule ALIAS 52_fft_mpi_noabirule)

=== src/56_mixing/CMakeLists.txt ===
#
# 56_mixing
#
add_library(56_mixing STATIC
  m_ab7_mixing.F90
  )

set_target_properties(56_mixing
  PROPERTIES
  Fortran_MODULE_DIRECTORY ${CMAKE_BINARY_DIR}/modules)

target_include_directories(56_mixing
  PRIVATE
  ${CMAKE_BINARY_DIR}
  ${CMAKE_SOURCE_DIR}/shared/common/src/incs
  PUBLIC
  ${CMAKE_BINARY_DIR}/modules
  )

target_compile_definitions(56_mixing
  PRIVATE
  HAVE_CONFIG_H)

target_link_libraries(56_mixing
  PUBLIC
  abinit::44_abitypes_defs
  )

if(OpenMP_FOUND)
  target_link_libraries(56_mixing
    PUBLIC
    OpenMP::OpenMP_Fortran)
endif()

add_library(abinit::56_mixing ALIAS 56_mixing)

=== src/61_occeig/CMakeLists.txt ===
#
# 61_occeig
#
add_library(61_occeig STATIC
  m_occ.F90
  m_ebands.F90
  m_fstab.F90
  m_extfpmd.F90
  )

set_target_properties(61_occeig
  PROPERTIES
  Fortran_MODULE_DIRECTORY ${CMAKE_BINARY_DIR}/modules)

target_include_directories(61_occeig
  PRIVATE
  ${CMAKE_BINARY_DIR}
  ${CMAKE_SOURCE_DIR}/shared/common/src/incs
  ${CMAKE_SOURCE_DIR}/src/incs
  PUBLIC
  ${CMAKE_BINARY_DIR}/modules
  )

target_compile_definitions(61_occeig
  PRIVATE
  HAVE_CONFIG_H)

target_link_libraries(61_occeig
  PUBLIC
  abinit::44_abitypes_defs
  abinit::56_recipspace
  abinit::56_io_mpi
  )

if(OpenMP_FOUND)
  target_link_libraries(61_occeig
    PUBLIC
    OpenMP::OpenMP_Fortran)
endif()

add_library(abinit::61_occeig ALIAS 61_occeig)

=== PKGBUILD ===
# Contributor: Mehdi Chinoune <mehdi.chinoune@hotmail.com>

_realname=abinit
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=10.4.7
pkgrel=1
pkgdesc="Atomic-scale simulation software. (mingw-w64)"
arch=('any')
mingw_arch=('ucrt64')
url='https://www.abinit.org'
msys2_repository_url="https://github.com/abinit/abinit"
msys2_references=(
  'aur: abinit'
)
license=('spdx:GPL-3.0-or-later')
depends=("${MINGW_PACKAGE_PREFIX}-fftw"
         "${MINGW_PACKAGE_PREFIX}-cc-libs"
         $([[ ${MINGW_PACKAGE_PREFIX} == *-clang-* ]] || echo "${MINGW_PACKAGE_PREFIX}-gcc-libgfortran")
         "${MINGW_PACKAGE_PREFIX}-libpsml"
         "${MINGW_PACKAGE_PREFIX}-libxc"
         "${MINGW_PACKAGE_PREFIX}-libxml2"
         "${MINGW_PACKAGE_PREFIX}-netcdf-fortran"
         "${MINGW_PACKAGE_PREFIX}-openblas"
         "${MINGW_PACKAGE_PREFIX}-omp")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-fc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-msmpi"
             "${MINGW_PACKAGE_PREFIX}-python"
             "${MINGW_PACKAGE_PREFIX}-wannier90")
source=("https://forge.abinit.org/${_realname}-${pkgver}.tar.gz"
        "001-fix-build-on-mingw.patch"
        "002-fix-pkgconfig-file.patch"
        "003-fix-version.patch"
        "004-include-missing-cmake-module.patch")
sha256sums=('161c60ef90686c19e0718363eb5a17bfa29494e5fbdc59be45a7342e20349768'
            '992bc51d0965fd96131cfd5f2630f88fdb8874bf05625543802434da570ec02e'
            '466f7f86384f02c99e9f7a948f2b38229a10962ff849cd1e8bf06b0c6ddd7481'
            'cfe9c539d96d62fe2b296513da431602aaf98d697cd61d1e9cbca2c329383e87'
            'bd9f482732e3ba7c8c5e11a2bc545808cd5e0891fb9a03f235dae9a4c5822976')

apply_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying $_patch"
    patch -Nbp1 -i "${srcdir}/$_patch"
  done
}

prepare() {
  cd "${srcdir}"/${_realname}-${pkgver}

  apply_patch_with_msg \
    001-fix-build-on-mingw.patch \
    002-fix-pkgconfig-file.patch \
    003-fix-version.patch \
    004-include-missing-cmake-module.patch
}

build() {
  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  if [[ ${CARCH} == x86_64 ]]; then
    FFLAGS="-march=x86-64-v3"
    CFLAGS+=" -march=x86-64-v3"
  fi

  FFLAGS+=" -O2" \
  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=;-DPYMOD_INSTALL_LIBDIR=" \
    "${MINGW_PREFIX}"/bin/cmake.exe -Wno-dev \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
      -DCMAKE_C_STANDARD=17 \
      "${_extra_config[@]}" \
      -DBLA_VENDOR=OpenBLAS \
      -DPython3_EXECUTABLE=${MINGW_PREFIX}/bin/python \
      -S "${_realname}-${pkgver}" \
      -B "build-${MSYSTEM}"

  "${MINGW_PREFIX}"/bin/cmake.exe --build "build-${MSYSTEM}"
}

package() {
  DESTDIR="${pkgdir}" "${MINGW_PREFIX}"/bin/cmake.exe --install "build-${MSYSTEM}"

  install -Dm644 "${srcdir}"/${_realname}-${pkgver}/COPYING \
    "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}/COPYING
}
